/*
 * VectorPositiveComponentsValidator.hpp
 *
 *  Created on: May 10, 2012
 *      Author: heber
 */

#ifndef VECTORPOSITIVECOMPONENTSVALIDATOR_HPP_
#define VECTORPOSITIVECOMPONENTSVALIDATOR_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "LinearAlgebra/Vector.hpp"

#include "Parameters/Validators/Validator.hpp"

/** This validator checks whether the given \ref Vector's components only have
 * (strictly) positive values.
 */
class VectorPositiveComponentsValidator : public Validator<Vector>
{
  bool isValid(const Vector & _value) const;
  bool operator==(const Validator<Vector> &_instance) const;
  Validator< Vector >* clone() const;
};


#endif /* VECTORPOSITIVECOMPONENTSVALIDATOR_HPP_ */
